// Generated by CoffeeScript 1.8.0
(function() {
  var skeleton;

  skeleton = function() {
    var settings, zappa;
    zappa = window.zappa = {};
    zappa.version = null;
    settings = null;
    return zappa.run = function(func) {
      var app, apply_helpers, context, helpers, route;
      context = {};
      helpers = {};
      apply_helpers = function(ctx) {
        var helper, name, _fn;
        _fn = function(name, helper) {
          if (typeof helper === 'function') {
            return ctx[name] = function() {
              return helper.apply(ctx, arguments);
            };
          } else {
            return ctx[name] = helper;
          }
        };
        for (name in helpers) {
          helper = helpers[name];
          _fn(name, helper);
        }
        return ctx;
      };
      if (typeof Sammy !== "undefined" && Sammy !== null) {
        app = context.app = Sammy();
      }
      context.get = function() {
        var k, v, _ref, _results;
        if (typeof arguments[0] !== 'object') {
          return route({
            path: arguments[0],
            handler: arguments[1]
          });
        } else {
          _ref = arguments[0];
          _results = [];
          for (k in _ref) {
            v = _ref[k];
            _results.push(route({
              path: k,
              handler: v
            }));
          }
          return _results;
        }
      };
      context.helper = function(obj) {
        var k, v, _results;
        _results = [];
        for (k in obj) {
          v = obj[k];
          _results.push(helpers[k] = v);
        }
        return _results;
      };
      context.on = function(obj) {
        var action, message, _results;
        _results = [];
        for (message in obj) {
          action = obj[message];
          _results.push(context.socket.on(message, function(data) {
            var ctx;
            ctx = {
              app: app,
              socket: context.socket,
              id: context.socket.id,
              data: data,
              emit: context.emit,
              share: context.share
            };
            apply_helpers(ctx);
            return action.apply(ctx);
          }));
        }
        return _results;
      };
      context.connect = function() {
        return context.socket = io.connect.apply(io, arguments);
      };
      context.emit = function() {
        var k, v, _ref, _results;
        if (typeof arguments[0] !== 'object') {
          return context.socket.emit.apply(context.socket, arguments);
        } else {
          _ref = arguments[0];
          _results = [];
          for (k in _ref) {
            v = _ref[k];
            _results.push(context.socket.emit.apply(context.socket, [k, v]));
          }
          return _results;
        }
      };
      context.share = function(channel, socket, cb) {
        var sessionid, zappa_prefix, _ref, _ref1, _ref2, _ref3;
        zappa_prefix = (_ref = settings.zappa_prefix) != null ? _ref : "";
        sessionid = (_ref1 = (_ref2 = socket.io) != null ? _ref2.engine.id : void 0) != null ? _ref1 : (_ref3 = socket.socket) != null ? _ref3.sessionid : void 0;
        if (sessionid != null) {
          return $.getJSON("" + zappa_prefix + "/socket/" + channel + "/" + sessionid, cb);
        }
      };
      route = function(r) {
        var ctx;
        ctx = {
          app: app
        };
        apply_helpers(ctx);
        return app.get(r.path, function(sammy_context) {
          ctx.params = sammy_context.params;
          ctx.sammy_context = sammy_context;
          ctx.render = function() {
            return sammy_context.render.apply(sammy_context, arguments);
          };
          ctx.redirect = function() {
            return sammy_context.redirect.apply(sammy_context, arguments);
          };
          return r.handler.apply(ctx);
        });
      };
      func.apply(context, [context]);
      if (context.socket != null) {
        context.socket.on('connect', function() {
          return context.share('__local', context.socket, function(data) {
            return context.key = data.key;
          });
        });
      }
      if (app != null) {
        return $(function() {
          return app.run('#/');
        });
      }
    };
  };

  this.build = function(version, settings) {
    return String(skeleton).replace('version = null;', "version = '" + version + "';").replace('settings = null;', "settings = " + (JSON.stringify(settings)) + ";");
  };

}).call(this);
